Solid Example: Aggregation

import {
  rowAggregationFeature,
  aggregationFn_count,
  aggregationFn_extent,
  aggregationFn_mean,
  aggregationFn_sum,
  columnFilteringFeature,
  createColumnHelper,
  createFilteredRowModel,
  createPaginatedRowModel,
  createTable,
  filterFn_includesString,
  metaHelper,
  rowPaginationFeature,
  rowSelectionFeature,
  tableFeatures,
} from '@tanstack/solid-table'
import { For, createSignal } from 'solid-js'
import { makeData } from './makeData'
import type { Sale } from './makeData'
import type { Table } from '@tanstack/solid-table'

type RowSource = 'all' | 'custom' | 'filtered' | 'page' | 'selected'
type AggregationTableMeta = { rowSource: RowSource }
const features = tableFeatures({
  rowAggregationFeature,
  columnFilteringFeature,
  rowPaginationFeature,
  rowSelectionFeature,
  filteredRowModel: createFilteredRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  filterFns: { includesString: filterFn_includesString },
  aggregationFns: {
    count: aggregationFn_count,
    extent: aggregationFn_extent,
    mean: aggregationFn_mean,
    sum: aggregationFn_sum,
  },
  tableMeta: metaHelper<AggregationTableMeta>(),
})
const columnHelper = createColumnHelper<typeof features, Sale>()
function getAggregationRows(
  table: Table<typeof features, Sale>,
  source = table.options.meta?.rowSource,
) {
  if (source === 'all') return table.getCoreRowModel().rows
  if (source === 'page') return table.getRowModel().rows
  if (source === 'selected') return table.getFilteredSelectedRowModel().rows
  if (source === 'custom') return table.getCoreRowModel().rows.slice(0, 3)
  return undefined
}
function formatValue(value: unknown): string {
  if (Array.isArray(value)) return value.map(formatValue).join(' – ')
  if (value && typeof value === 'object')
    return Object.entries(value)
      .map(([key, entry]) => `${key}: ${formatValue(entry)}`)
      .join(', ')
  if (typeof value === 'number')
    return value.toLocaleString(undefined, { maximumFractionDigits: 2 })
  return String(value ?? '—')
}

function App() {
  const [data, setData] = createSignal(makeData(10_000))
  const [rowSource, setRowSource] = createSignal<RowSource>('filtered')
  const columns = columnHelper.columns([
    columnHelper.display({
      id: 'select',
      header: ({ table }) => (
        <input
          type="checkbox"
          checked={table.getIsAllPageRowsSelected()}
          onChange={table.getToggleAllPageRowsSelectedHandler()}
        />
      ),
      cell: ({ row }) => (
        <input
          type="checkbox"
          checked={row.getIsSelected()}
          onChange={row.getToggleSelectedHandler()}
        />
      ),
    }),
    columnHelper.accessor('category', {
      header: 'Category',
      filterFn: 'includesString',
    }),
    columnHelper.accessor('item', {
      header: 'Item',
      footer: () => `${rowSource()} total`,
    }),
    columnHelper.accessor('amount', {
      header: 'Amount',
      aggregationFn: 'sum',
      cell: ({ getValue }) => getValue<number>().toLocaleString(),
      footer: ({ column, table }) =>
        formatValue(
          column.getAggregationValue({
            rows: getAggregationRows(table, rowSource()),
          }),
        ),
    }),
    columnHelper.accessor('score', {
      header: 'Score',
      aggregationFn: [
        'count',
        'mean',
        { id: 'range', aggregationFn: 'extent' },
      ],
      footer: ({ column, table }) =>
        formatValue(
          column.getAggregationValue({
            rows: getAggregationRows(table, rowSource()),
          }),
        ),
    }),
  ])
  const table = createTable({
    features,
    columns,
    get data() {
      return data()
    },
    get meta() {
      return { rowSource: rowSource() }
    },
    initialState: { pagination: { pageIndex: 0, pageSize: 10 } },
    // manualAggregation: true, // supply aggregate values yourself instead of calculating them locally
    debugTable: true,
    debugColumns: true,
  })
  const changeRowSource = (value: RowSource) => {
    setRowSource(value)
    table.setOptions((previous) => ({
      ...previous,
      meta: { rowSource: value },
    }))
  }
  const changeData = (value: Array<Sale>) => {
    setData(value)
    table.setOptions((previous) => ({ ...previous, data: value }))
  }
  return (
    <div class="demo-root">
      <h1>Aggregation without grouping</h1>
      <p>
        Amount uses a scalar <code>sum</code>. Score runs count, mean, and range
        together and returns a keyed object.
      </p>
      <div>
        <button onClick={() => changeData(makeData(10_000))}>
          Regenerate Data
        </button>
        <button onClick={() => changeData(makeData(1_000_000))}>
          Stress Test (1M rows)
        </button>
      </div>
      <div class="spacer-sm" />
      <div class="controls">
        <label>
          Category filter:{' '}
          <input
            value={
              (table.getColumn('category')?.getFilterValue() ?? '') as string
            }
            onInput={(event) =>
              table
                .getColumn('category')
                ?.setFilterValue(event.currentTarget.value)
            }
          />
        </label>
        <label>
          Total rows:{' '}
          <select
            value={rowSource()}
            onChange={(event) =>
              changeRowSource(event.currentTarget.value as RowSource)
            }
          >
            <option value="filtered">Filtered rows</option>
            <option value="all">All rows</option>
            <option value="page">Visible page</option>
            <option value="selected">Filtered selected rows</option>
            <option value="custom">First three core rows</option>
          </select>
        </label>
      </div>
      <div class="spacer-sm" />
      <table>
        <thead>
          <For each={table.getHeaderGroups()}>
            {(group) => (
              <tr>
                <For each={group.headers}>
                  {(header) => (
                    <th>
                      {header.isPlaceholder ? null : (
                        <table.FlexRender header={header} />
                      )}
                    </th>
                  )}
                </For>
              </tr>
            )}
          </For>
        </thead>
        <tbody>
          <For each={table.getRowModel().rows}>
            {(row) => (
              <tr>
                <For each={row.getAllCells()}>
                  {(cell) => (
                    <td
                      class={
                        cell.column.id === 'amount' ? 'numeric' : undefined
                      }
                    >
                      <table.FlexRender cell={cell} />
                    </td>
                  )}
                </For>
              </tr>
            )}
          </For>
        </tbody>
        <tfoot>
          <For each={table.getFooterGroups()}>
            {(group) => (
              <tr>
                <For each={group.headers}>
                  {(header) => (
                    <th colSpan={header.colSpan}>
                      {header.isPlaceholder ? null : header.column.id ===
                        'item' ? (
                        `${rowSource()} total`
                      ) : header.column.id === 'amount' ||
                        header.column.id === 'score' ? (
                        formatValue(
                          header.column.getAggregationValue({
                            rows: getAggregationRows(table, rowSource()),
                          }),
                        )
                      ) : (
                        <table.FlexRender footer={header} />
                      )}
                    </th>
                  )}
                </For>
              </tr>
            )}
          </For>
        </tfoot>
      </table>
      <div class="spacer-sm" />
      <div class="controls">
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.firstPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.lastPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span class="inline-controls">
          <div>Page</div>
          <strong>
            {(table.atoms.pagination.get().pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span class="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.atoms.pagination.get().pageIndex + 1}
            onInput={(event) =>
              table.setPageIndex(
                event.currentTarget.value
                  ? Number(event.currentTarget.value) - 1
                  : 0,
              )
            }
            class="page-size-input"
          />
        </span>
        <select
          value={table.atoms.pagination.get().pageSize}
          onChange={(event) =>
            table.setPageSize(Number(event.currentTarget.value))
          }
        >
          <For each={[10, 20, 30, 40, 50]}>
            {(size) => <option value={size}>Show {size}</option>}
          </For>
        </select>
      </div>
      <div>
        Showing {table.getRowModel().rows.length.toLocaleString()} of{' '}
        {table.getRowCount().toLocaleString()} Rows
      </div>
      <pre data-testid="table-state">
        {JSON.stringify(table.store.get(), null, 2)}
      </pre>
    </div>
  )
}
export default App
import {
  rowAggregationFeature,
  aggregationFn_count,
  aggregationFn_extent,
  aggregationFn_mean,
  aggregationFn_sum,
  columnFilteringFeature,
  createColumnHelper,
  createFilteredRowModel,
  createPaginatedRowModel,
  createTable,
  filterFn_includesString,
  metaHelper,
  rowPaginationFeature,
  rowSelectionFeature,
  tableFeatures,
} from '@tanstack/solid-table'
import { For, createSignal } from 'solid-js'
import { makeData } from './makeData'
import type { Sale } from './makeData'
import type { Table } from '@tanstack/solid-table'

type RowSource = 'all' | 'custom' | 'filtered' | 'page' | 'selected'
type AggregationTableMeta = { rowSource: RowSource }
const features = tableFeatures({
  rowAggregationFeature,
  columnFilteringFeature,
  rowPaginationFeature,
  rowSelectionFeature,
  filteredRowModel: createFilteredRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  filterFns: { includesString: filterFn_includesString },
  aggregationFns: {
    count: aggregationFn_count,
    extent: aggregationFn_extent,
    mean: aggregationFn_mean,
    sum: aggregationFn_sum,
  },
  tableMeta: metaHelper<AggregationTableMeta>(),
})
const columnHelper = createColumnHelper<typeof features, Sale>()
function getAggregationRows(
  table: Table<typeof features, Sale>,
  source = table.options.meta?.rowSource,
) {
  if (source === 'all') return table.getCoreRowModel().rows
  if (source === 'page') return table.getRowModel().rows
  if (source === 'selected') return table.getFilteredSelectedRowModel().rows
  if (source === 'custom') return table.getCoreRowModel().rows.slice(0, 3)
  return undefined
}
function formatValue(value: unknown): string {
  if (Array.isArray(value)) return value.map(formatValue).join(' – ')
  if (value && typeof value === 'object')
    return Object.entries(value)
      .map(([key, entry]) => `${key}: ${formatValue(entry)}`)
      .join(', ')
  if (typeof value === 'number')
    return value.toLocaleString(undefined, { maximumFractionDigits: 2 })
  return String(value ?? '—')
}

function App() {
  const [data, setData] = createSignal(makeData(10_000))
  const [rowSource, setRowSource] = createSignal<RowSource>('filtered')
  const columns = columnHelper.columns([
    columnHelper.display({
      id: 'select',
      header: ({ table }) => (
        <input
          type="checkbox"
          checked={table.getIsAllPageRowsSelected()}
          onChange={table.getToggleAllPageRowsSelectedHandler()}
        />
      ),
      cell: ({ row }) => (
        <input
          type="checkbox"
          checked={row.getIsSelected()}
          onChange={row.getToggleSelectedHandler()}
        />
      ),
    }),
    columnHelper.accessor('category', {
      header: 'Category',
      filterFn: 'includesString',
    }),
    columnHelper.accessor('item', {
      header: 'Item',
      footer: () => `${rowSource()} total`,
    }),
    columnHelper.accessor('amount', {
      header: 'Amount',
      aggregationFn: 'sum',
      cell: ({ getValue }) => getValue<number>().toLocaleString(),
      footer: ({ column, table }) =>
        formatValue(
          column.getAggregationValue({
            rows: getAggregationRows(table, rowSource()),
          }),
        ),
    }),
    columnHelper.accessor('score', {
      header: 'Score',
      aggregationFn: [
        'count',
        'mean',
        { id: 'range', aggregationFn: 'extent' },
      ],
      footer: ({ column, table }) =>
        formatValue(
          column.getAggregationValue({
            rows: getAggregationRows(table, rowSource()),
          }),
        ),
    }),
  ])
  const table = createTable({
    features,
    columns,
    get data() {
      return data()
    },
    get meta() {
      return { rowSource: rowSource() }
    },
    initialState: { pagination: { pageIndex: 0, pageSize: 10 } },
    // manualAggregation: true, // supply aggregate values yourself instead of calculating them locally
    debugTable: true,
    debugColumns: true,
  })
  const changeRowSource = (value: RowSource) => {
    setRowSource(value)
    table.setOptions((previous) => ({
      ...previous,
      meta: { rowSource: value },
    }))
  }
  const changeData = (value: Array<Sale>) => {
    setData(value)
    table.setOptions((previous) => ({ ...previous, data: value }))
  }
  return (
    <div class="demo-root">
      <h1>Aggregation without grouping</h1>
      <p>
        Amount uses a scalar <code>sum</code>. Score runs count, mean, and range
        together and returns a keyed object.
      </p>
      <div>
        <button onClick={() => changeData(makeData(10_000))}>
          Regenerate Data
        </button>
        <button onClick={() => changeData(makeData(1_000_000))}>
          Stress Test (1M rows)
        </button>
      </div>
      <div class="spacer-sm" />
      <div class="controls">
        <label>
          Category filter:{' '}
          <input
            value={
              (table.getColumn('category')?.getFilterValue() ?? '') as string
            }
            onInput={(event) =>
              table
                .getColumn('category')
                ?.setFilterValue(event.currentTarget.value)
            }
          />
        </label>
        <label>
          Total rows:{' '}
          <select
            value={rowSource()}
            onChange={(event) =>
              changeRowSource(event.currentTarget.value as RowSource)
            }
          >
            <option value="filtered">Filtered rows</option>
            <option value="all">All rows</option>
            <option value="page">Visible page</option>
            <option value="selected">Filtered selected rows</option>
            <option value="custom">First three core rows</option>
          </select>
        </label>
      </div>
      <div class="spacer-sm" />
      <table>
        <thead>
          <For each={table.getHeaderGroups()}>
            {(group) => (
              <tr>
                <For each={group.headers}>
                  {(header) => (
                    <th>
                      {header.isPlaceholder ? null : (
                        <table.FlexRender header={header} />
                      )}
                    </th>
                  )}
                </For>
              </tr>
            )}
          </For>
        </thead>
        <tbody>
          <For each={table.getRowModel().rows}>
            {(row) => (
              <tr>
                <For each={row.getAllCells()}>
                  {(cell) => (
                    <td
                      class={
                        cell.column.id === 'amount' ? 'numeric' : undefined
                      }
                    >
                      <table.FlexRender cell={cell} />
                    </td>
                  )}
                </For>
              </tr>
            )}
          </For>
        </tbody>
        <tfoot>
          <For each={table.getFooterGroups()}>
            {(group) => (
              <tr>
                <For each={group.headers}>
                  {(header) => (
                    <th colSpan={header.colSpan}>
                      {header.isPlaceholder ? null : header.column.id ===
                        'item' ? (
                        `${rowSource()} total`
                      ) : header.column.id === 'amount' ||
                        header.column.id === 'score' ? (
                        formatValue(
                          header.column.getAggregationValue({
                            rows: getAggregationRows(table, rowSource()),
                          }),
                        )
                      ) : (
                        <table.FlexRender footer={header} />
                      )}
                    </th>
                  )}
                </For>
              </tr>
            )}
          </For>
        </tfoot>
      </table>
      <div class="spacer-sm" />
      <div class="controls">
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.firstPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.lastPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span class="inline-controls">
          <div>Page</div>
          <strong>
            {(table.atoms.pagination.get().pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span class="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.atoms.pagination.get().pageIndex + 1}
            onInput={(event) =>
              table.setPageIndex(
                event.currentTarget.value
                  ? Number(event.currentTarget.value) - 1
                  : 0,
              )
            }
            class="page-size-input"
          />
        </span>
        <select
          value={table.atoms.pagination.get().pageSize}
          onChange={(event) =>
            table.setPageSize(Number(event.currentTarget.value))
          }
        >
          <For each={[10, 20, 30, 40, 50]}>
            {(size) => <option value={size}>Show {size}</option>}
          </For>
        </select>
      </div>
      <div>
        Showing {table.getRowModel().rows.length.toLocaleString()} of{' '}
        {table.getRowCount().toLocaleString()} Rows
      </div>
      <pre data-testid="table-state">
        {JSON.stringify(table.store.get(), null, 2)}
      </pre>
    </div>
  )
}
export default App

Svelte Example: Aggregation

<script lang="ts">
  import { FlexRender, rowAggregationFeature, aggregationFn_count, aggregationFn_extent, aggregationFn_mean, aggregationFn_sum, columnFilteringFeature, createColumnHelper, createFilteredRowModel, createPaginatedRowModel, createTable, filterFn_includesString, metaHelper, rowPaginationFeature, rowSelectionFeature, tableFeatures } from '@tanstack/svelte-table'
  import { makeData } from './makeData'
  import type { Sale } from './makeData'
  import type { Table } from '@tanstack/svelte-table'
  import './index.css'
  type RowSource = 'all' | 'custom' | 'filtered' | 'page' | 'selected'
  type AggregationTableMeta = { rowSource: RowSource }
  const features = tableFeatures({
    rowAggregationFeature, columnFilteringFeature, rowPaginationFeature, rowSelectionFeature,
    filteredRowModel: createFilteredRowModel(), paginatedRowModel: createPaginatedRowModel(),
    filterFns: { includesString: filterFn_includesString },
    aggregationFns: { count: aggregationFn_count, extent: aggregationFn_extent, mean: aggregationFn_mean, sum: aggregationFn_sum },
    tableMeta: metaHelper<AggregationTableMeta>(),
  })
  const columnHelper = createColumnHelper<typeof features, Sale>()
  function getAggregationRows(table: Table<typeof features, Sale>) {
    const source = table.options.meta?.rowSource
    if (source === 'all') return table.getCoreRowModel().rows
    if (source === 'page') return table.getRowModel().rows
    if (source === 'selected') return table.getFilteredSelectedRowModel().rows
    if (source === 'custom') return table.getCoreRowModel().rows.slice(0, 3)
    return undefined
  }
  function formatValue(value: unknown): string {
    if (Array.isArray(value)) return value.map(formatValue).join(' – ')
    if (value && typeof value === 'object') return Object.entries(value).map(([key, entry]) => `${key}: ${formatValue(entry)}`).join(', ')
    if (typeof value === 'number') return value.toLocaleString(undefined, { maximumFractionDigits: 2 })
    return String(value ?? '—')
  }
  let data = $state(makeData(10_000))
  let rowSource = $state<RowSource>('filtered')
  const columns = columnHelper.columns([
    columnHelper.display({ id: 'select' }),
    columnHelper.accessor('category', { header: 'Category', filterFn: 'includesString' }),
    columnHelper.accessor('item', { header: 'Item', footer: ({ table }) => `${table.options.meta?.rowSource} total` }),
    columnHelper.accessor('amount', { header: 'Amount', aggregationFn: 'sum', cell: ({ getValue }) => getValue<number>().toLocaleString(), footer: ({ column, table }) => formatValue(column.getAggregationValue({ rows: getAggregationRows(table) })) }),
    columnHelper.accessor('score', { header: 'Score', aggregationFn: ['count', 'mean', { id: 'range', aggregationFn: 'extent' }], footer: ({ column, table }) => formatValue(column.getAggregationValue({ rows: getAggregationRows(table) })) }),
  ])
  const table = createTable({
    features, columns,
    get data() { return data },
    get meta() { return { rowSource } },
    initialState: { pagination: { pageIndex: 0, pageSize: 10 } },
    // manualAggregation: true, // supply aggregate values yourself instead of calculating them locally
    debugTable: true, debugColumns: true,
  })
  const pagination = $derived(table.atoms.pagination.get())
  function changeRowSource(value: RowSource) {
    rowSource = value
    table.setOptions((previous) => ({ ...previous, meta: { rowSource: value } }))
  }
</script>

<div class="demo-root">
  <h1>Aggregation without grouping</h1>
  <p>Amount uses a scalar <code>sum</code>. Score runs count, mean, and range together and returns a keyed object.</p>
  <div><button onclick={() => data = makeData(10_000)}>Regenerate Data</button><button onclick={() => data = makeData(1_000_000)}>Stress Test (1M rows)</button></div>
  <div class="spacer-sm"></div>
  <div class="controls">
    <label>Category filter: <input value={(table.getColumn('category')?.getFilterValue() ?? '') as string} oninput={(event) => table.getColumn('category')?.setFilterValue(event.currentTarget.value)} /></label>
    <label>Total rows: <select value={rowSource} onchange={(event) => changeRowSource(event.currentTarget.value as RowSource)}><option value="filtered">Filtered rows</option><option value="all">All rows</option><option value="page">Visible page</option><option value="selected">Filtered selected rows</option><option value="custom">First three core rows</option></select></label>
  </div>
  <div class="spacer-sm"></div>
  <table>
    <thead>{#each table.getHeaderGroups() as group (group.id)}<tr>{#each group.headers as header (header.id)}<th>{#if header.column.id === 'select'}<input type="checkbox" checked={table.getIsAllPageRowsSelected()} onchange={() => table.toggleAllPageRowsSelected()} />{:else if !header.isPlaceholder}<FlexRender {header} />{/if}</th>{/each}</tr>{/each}</thead>
    <tbody>{#each table.getRowModel().rows as row (row.id)}<tr>{#each row.getAllCells() as cell (cell.id)}<td class:numeric={cell.column.id === 'amount'}>{#if cell.column.id === 'select'}<input type="checkbox" checked={row.getIsSelected()} onchange={() => row.toggleSelected()} />{:else}<FlexRender {cell} />{/if}</td>{/each}</tr>{/each}</tbody>
    <tfoot>{#each table.getFooterGroups() as group (group.id)}<tr>{#each group.headers as header (header.id)}<th colspan={header.colSpan}>{#if !header.isPlaceholder}<FlexRender footer={header} />{/if}</th>{/each}</tr>{/each}</tfoot>
  </table>
  <div class="spacer-sm"></div>
  <div class="controls"><button class="demo-button demo-button-sm" onclick={() => table.firstPage()} disabled={!table.getCanPreviousPage()}>{'<<'}</button><button class="demo-button demo-button-sm" onclick={() => table.previousPage()} disabled={!table.getCanPreviousPage()}>{'<'}</button><button class="demo-button demo-button-sm" onclick={() => table.nextPage()} disabled={!table.getCanNextPage()}>{'>'}</button><button class="demo-button demo-button-sm" onclick={() => table.lastPage()} disabled={!table.getCanNextPage()}>{'>>'}</button>
    <span class="inline-controls"><div>Page</div><strong>{(pagination.pageIndex + 1).toLocaleString()} of {table.getPageCount().toLocaleString()}</strong></span>
    <span class="inline-controls">| Go to page:<input type="number" min="1" max={table.getPageCount()} value={pagination.pageIndex + 1} oninput={(event) => table.setPageIndex(event.currentTarget.value ? Number(event.currentTarget.value) - 1 : 0)} class="page-size-input" /></span>
    <select value={pagination.pageSize} onchange={(event) => table.setPageSize(Number(event.currentTarget.value))}>{#each [10,20,30,40,50] as size}<option value={size}>Show {size}</option>{/each}</select>
  </div>
  <div>Showing {table.getRowModel().rows.length.toLocaleString()} of {table.getRowCount().toLocaleString()} Rows</div><pre data-testid="table-state">{JSON.stringify(table.store.get(), null, 2)}</pre>
</div>
<script lang="ts">
  import { FlexRender, rowAggregationFeature, aggregationFn_count, aggregationFn_extent, aggregationFn_mean, aggregationFn_sum, columnFilteringFeature, createColumnHelper, createFilteredRowModel, createPaginatedRowModel, createTable, filterFn_includesString, metaHelper, rowPaginationFeature, rowSelectionFeature, tableFeatures } from '@tanstack/svelte-table'
  import { makeData } from './makeData'
  import type { Sale } from './makeData'
  import type { Table } from '@tanstack/svelte-table'
  import './index.css'
  type RowSource = 'all' | 'custom' | 'filtered' | 'page' | 'selected'
  type AggregationTableMeta = { rowSource: RowSource }
  const features = tableFeatures({
    rowAggregationFeature, columnFilteringFeature, rowPaginationFeature, rowSelectionFeature,
    filteredRowModel: createFilteredRowModel(), paginatedRowModel: createPaginatedRowModel(),
    filterFns: { includesString: filterFn_includesString },
    aggregationFns: { count: aggregationFn_count, extent: aggregationFn_extent, mean: aggregationFn_mean, sum: aggregationFn_sum },
    tableMeta: metaHelper<AggregationTableMeta>(),
  })
  const columnHelper = createColumnHelper<typeof features, Sale>()
  function getAggregationRows(table: Table<typeof features, Sale>) {
    const source = table.options.meta?.rowSource
    if (source === 'all') return table.getCoreRowModel().rows
    if (source === 'page') return table.getRowModel().rows
    if (source === 'selected') return table.getFilteredSelectedRowModel().rows
    if (source === 'custom') return table.getCoreRowModel().rows.slice(0, 3)
    return undefined
  }
  function formatValue(value: unknown): string {
    if (Array.isArray(value)) return value.map(formatValue).join(' – ')
    if (value && typeof value === 'object') return Object.entries(value).map(([key, entry]) => `${key}: ${formatValue(entry)}`).join(', ')
    if (typeof value === 'number') return value.toLocaleString(undefined, { maximumFractionDigits: 2 })
    return String(value ?? '—')
  }
  let data = $state(makeData(10_000))
  let rowSource = $state<RowSource>('filtered')
  const columns = columnHelper.columns([
    columnHelper.display({ id: 'select' }),
    columnHelper.accessor('category', { header: 'Category', filterFn: 'includesString' }),
    columnHelper.accessor('item', { header: 'Item', footer: ({ table }) => `${table.options.meta?.rowSource} total` }),
    columnHelper.accessor('amount', { header: 'Amount', aggregationFn: 'sum', cell: ({ getValue }) => getValue<number>().toLocaleString(), footer: ({ column, table }) => formatValue(column.getAggregationValue({ rows: getAggregationRows(table) })) }),
    columnHelper.accessor('score', { header: 'Score', aggregationFn: ['count', 'mean', { id: 'range', aggregationFn: 'extent' }], footer: ({ column, table }) => formatValue(column.getAggregationValue({ rows: getAggregationRows(table) })) }),
  ])
  const table = createTable({
    features, columns,
    get data() { return data },
    get meta() { return { rowSource } },
    initialState: { pagination: { pageIndex: 0, pageSize: 10 } },
    // manualAggregation: true, // supply aggregate values yourself instead of calculating them locally
    debugTable: true, debugColumns: true,
  })
  const pagination = $derived(table.atoms.pagination.get())
  function changeRowSource(value: RowSource) {
    rowSource = value
    table.setOptions((previous) => ({ ...previous, meta: { rowSource: value } }))
  }
</script>

<div class="demo-root">
  <h1>Aggregation without grouping</h1>
  <p>Amount uses a scalar <code>sum</code>. Score runs count, mean, and range together and returns a keyed object.</p>
  <div><button onclick={() => data = makeData(10_000)}>Regenerate Data</button><button onclick={() => data = makeData(1_000_000)}>Stress Test (1M rows)</button></div>
  <div class="spacer-sm"></div>
  <div class="controls">
    <label>Category filter: <input value={(table.getColumn('category')?.getFilterValue() ?? '') as string} oninput={(event) => table.getColumn('category')?.setFilterValue(event.currentTarget.value)} /></label>
    <label>Total rows: <select value={rowSource} onchange={(event) => changeRowSource(event.currentTarget.value as RowSource)}><option value="filtered">Filtered rows</option><option value="all">All rows</option><option value="page">Visible page</option><option value="selected">Filtered selected rows</option><option value="custom">First three core rows</option></select></label>
  </div>
  <div class="spacer-sm"></div>
  <table>
    <thead>{#each table.getHeaderGroups() as group (group.id)}<tr>{#each group.headers as header (header.id)}<th>{#if header.column.id === 'select'}<input type="checkbox" checked={table.getIsAllPageRowsSelected()} onchange={() => table.toggleAllPageRowsSelected()} />{:else if !header.isPlaceholder}<FlexRender {header} />{/if}</th>{/each}</tr>{/each}</thead>
    <tbody>{#each table.getRowModel().rows as row (row.id)}<tr>{#each row.getAllCells() as cell (cell.id)}<td class:numeric={cell.column.id === 'amount'}>{#if cell.column.id === 'select'}<input type="checkbox" checked={row.getIsSelected()} onchange={() => row.toggleSelected()} />{:else}<FlexRender {cell} />{/if}</td>{/each}</tr>{/each}</tbody>
    <tfoot>{#each table.getFooterGroups() as group (group.id)}<tr>{#each group.headers as header (header.id)}<th colspan={header.colSpan}>{#if !header.isPlaceholder}<FlexRender footer={header} />{/if}</th>{/each}</tr>{/each}</tfoot>
  </table>
  <div class="spacer-sm"></div>
  <div class="controls"><button class="demo-button demo-button-sm" onclick={() => table.firstPage()} disabled={!table.getCanPreviousPage()}>{'<<'}</button><button class="demo-button demo-button-sm" onclick={() => table.previousPage()} disabled={!table.getCanPreviousPage()}>{'<'}</button><button class="demo-button demo-button-sm" onclick={() => table.nextPage()} disabled={!table.getCanNextPage()}>{'>'}</button><button class="demo-button demo-button-sm" onclick={() => table.lastPage()} disabled={!table.getCanNextPage()}>{'>>'}</button>
    <span class="inline-controls"><div>Page</div><strong>{(pagination.pageIndex + 1).toLocaleString()} of {table.getPageCount().toLocaleString()}</strong></span>
    <span class="inline-controls">| Go to page:<input type="number" min="1" max={table.getPageCount()} value={pagination.pageIndex + 1} oninput={(event) => table.setPageIndex(event.currentTarget.value ? Number(event.currentTarget.value) - 1 : 0)} class="page-size-input" /></span>
    <select value={pagination.pageSize} onchange={(event) => table.setPageSize(Number(event.currentTarget.value))}>{#each [10,20,30,40,50] as size}<option value={size}>Show {size}</option>{/each}</select>
  </div>
  <div>Showing {table.getRowModel().rows.length.toLocaleString()} of {table.getRowCount().toLocaleString()} Rows</div><pre data-testid="table-state">{JSON.stringify(table.store.get(), null, 2)}</pre>
</div>

React Example: Aggregation

import React from 'react'
import ReactDOM from 'react-dom/client'
import './index.css'
import {
  rowAggregationFeature,
  aggregationFn_count,
  aggregationFn_extent,
  aggregationFn_mean,
  aggregationFn_sum,
  columnFilteringFeature,
  createColumnHelper,
  createFilteredRowModel,
  createPaginatedRowModel,
  filterFn_includesString,
  metaHelper,
  rowPaginationFeature,
  rowSelectionFeature,
  useTable,
} from '@tanstack/react-table'
import { makeData } from './makeData'
import type { Table } from '@tanstack/react-table'
import type { Sale } from './makeData'

type RowSource = 'all' | 'custom' | 'filtered' | 'page' | 'selected'

type AggregationTableMeta = {
  rowSource: RowSource
}

const features = {
  rowAggregationFeature,
  columnFilteringFeature,
  rowPaginationFeature,
  rowSelectionFeature,
  filteredRowModel: createFilteredRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  filterFns: { includesString: filterFn_includesString },
  aggregationFns: {
    count: aggregationFn_count,
    extent: aggregationFn_extent,
    mean: aggregationFn_mean,
    sum: aggregationFn_sum,
  },
  tableMeta: metaHelper<AggregationTableMeta>(),
}

const columnHelper = createColumnHelper<typeof features, Sale>()

// demo purposes - optionally pass in custom rows to aggregate
function getAggregationRows(table: Table<typeof features, Sale>) {
  const rowSource = table.options.meta?.rowSource
  if (rowSource === 'all') return table.getCoreRowModel().rows
  if (rowSource === 'page') return table.getRowModel().rows
  if (rowSource === 'selected') {
    return table.getFilteredSelectedRowModel().rows
  }
  if (rowSource === 'custom') {
    return table.getCoreRowModel().rows.slice(0, 3)
  }
  return undefined
}

function formatValue(value: unknown): string {
  if (Array.isArray(value)) return value.map(formatValue).join(' – ')
  if (value && typeof value === 'object') {
    return Object.entries(value)
      .map(([key, entry]) => `${key}: ${formatValue(entry)}`)
      .join(', ')
  }
  if (typeof value === 'number')
    return value.toLocaleString(undefined, { maximumFractionDigits: 2 })
  return String(value ?? '—')
}

function App() {
  const [data, setData] = React.useState(() => makeData(10_000))
  const [rowSource, setRowSource] = React.useState<RowSource>('filtered')
  const columns = React.useMemo(
    () =>
      columnHelper.columns([
        columnHelper.display({
          id: 'select',
          header: ({ table }) => (
            <input
              type="checkbox"
              checked={table.getIsAllPageRowsSelected()}
              onChange={table.getToggleAllPageRowsSelectedHandler()}
            />
          ),
          cell: ({ row }) => (
            <input
              type="checkbox"
              checked={row.getIsSelected()}
              onChange={row.getToggleSelectedHandler()}
            />
          ),
        }),
        columnHelper.accessor('category', {
          header: 'Category',
          filterFn: 'includesString',
        }),
        columnHelper.accessor('item', {
          header: 'Item',
          footer: ({ table }) => `${table.options.meta?.rowSource} total`,
        }),
        columnHelper.accessor('amount', {
          header: 'Amount',
          aggregationFn: 'sum',
          // maxAggregationDepth: 1, // include one level of descendants in this column's aggregate
          // getAggregationValue: () => ({ value: 0 }), // provide a precomputed value and skip local fallback
          cell: ({ getValue }) => getValue<number>().toLocaleString(),
          footer: ({ column, table }) =>
            formatValue(
              column.getAggregationValue({
                // Omit `rows` to use the filtered, pre-grouped rows by default.
                rows: getAggregationRows(table),
              }),
            ),
        }),
        columnHelper.accessor('score', {
          header: 'Score',
          aggregationFn: [
            'count',
            'mean',
            { id: 'range', aggregationFn: 'extent' },
          ],
          footer: ({ column, table }) =>
            formatValue(
              column.getAggregationValue({
                // Any row model or custom subset can define the total's roots.
                rows: getAggregationRows(table),
              }),
            ),
        }),
      ]),
    [],
  )

  const table = useTable(
    {
      features,
      columns,
      data,
      meta: { rowSource },
      initialState: { pagination: { pageIndex: 0, pageSize: 10 } },
      // manualAggregation: true, // supply aggregate values yourself instead of calculating them locally
      debugTable: true,
      debugColumns: true,
    },
    (state) => state, // default selector
  )

  return (
    <div className="demo-root">
      <h1>Aggregation without grouping</h1>
      <p>
        Amount uses a scalar <code>sum</code>. Score runs count, mean, and range
        together and returns a keyed object.
      </p>
      <div>
        <button onClick={() => setData(makeData(10_000))}>
          Regenerate Data
        </button>
        <button onClick={() => setData(makeData(1_000_000))}>
          Stress Test (1M rows)
        </button>
      </div>
      <div className="spacer-sm" />
      <div className="controls">
        <label>
          Category filter:{' '}
          <input
            value={
              (table.getColumn('category')?.getFilterValue() ?? '') as string
            }
            onChange={(event) =>
              table.getColumn('category')?.setFilterValue(event.target.value)
            }
          />
        </label>
        <label>
          Total rows:{' '}
          <select
            value={rowSource}
            onChange={(event) => setRowSource(event.target.value as RowSource)}
          >
            <option value="filtered">Filtered rows</option>
            <option value="all">All rows</option>
            <option value="page">Visible page</option>
            <option value="selected">Filtered selected rows</option>
            <option value="custom">First three core rows</option>
          </select>
        </label>
      </div>
      <div className="spacer-sm" />
      <table>
        <thead>
          {table.getHeaderGroups().map((headerGroup) => (
            <tr key={headerGroup.id}>
              {headerGroup.headers.map((header) => (
                <th key={header.id}>
                  {header.isPlaceholder ? null : (
                    <table.FlexRender header={header} />
                  )}
                </th>
              ))}
            </tr>
          ))}
        </thead>
        <tbody>
          {table.getRowModel().rows.map((row) => (
            <tr key={row.id}>
              {row.getAllCells().map((cell) => (
                <td
                  key={cell.id}
                  className={
                    cell.column.id === 'amount' ? 'numeric' : undefined
                  }
                >
                  <table.FlexRender cell={cell} />
                </td>
              ))}
            </tr>
          ))}
        </tbody>
        <tfoot>
          {table.getFooterGroups().map((footerGroup) => (
            <tr key={footerGroup.id}>
              {footerGroup.headers.map((header) => (
                <th key={header.id} colSpan={header.colSpan}>
                  {header.isPlaceholder ? null : (
                    <table.FlexRender footer={header} />
                  )}
                </th>
              ))}
            </tr>
          ))}
        </tfoot>
      </table>
      <div className="spacer-sm" />
      <div className="controls">
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.firstPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.lastPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span className="inline-controls">
          <div>Page</div>
          <strong>
            {(table.state.pagination.pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span className="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.state.pagination.pageIndex + 1}
            onChange={(event) => {
              const page = event.target.value
                ? Number(event.target.value) - 1
                : 0
              table.setPageIndex(page)
            }}
            className="page-size-input"
          />
        </span>
        <select
          value={table.state.pagination.pageSize}
          onChange={(event) => table.setPageSize(Number(event.target.value))}
        >
          {[10, 20, 30, 40, 50].map((pageSize) => (
            <option key={pageSize} value={pageSize}>
              Show {pageSize}
            </option>
          ))}
        </select>
      </div>
      <div>
        Showing {table.getRowModel().rows.length.toLocaleString()} of{' '}
        {table.getRowCount().toLocaleString()} Rows
      </div>
      <pre data-testid="table-state">
        {JSON.stringify(table.state, null, 2)}
      </pre>
    </div>
  )
}

const rootElement = document.getElementById('root')
if (!rootElement) throw new Error('Failed to find the root element')
ReactDOM.createRoot(rootElement).render(
  <React.StrictMode>
    <App />
  </React.StrictMode>,
)
import React from 'react'
import ReactDOM from 'react-dom/client'
import './index.css'
import {
  rowAggregationFeature,
  aggregationFn_count,
  aggregationFn_extent,
  aggregationFn_mean,
  aggregationFn_sum,
  columnFilteringFeature,
  createColumnHelper,
  createFilteredRowModel,
  createPaginatedRowModel,
  filterFn_includesString,
  metaHelper,
  rowPaginationFeature,
  rowSelectionFeature,
  useTable,
} from '@tanstack/react-table'
import { makeData } from './makeData'
import type { Table } from '@tanstack/react-table'
import type { Sale } from './makeData'

type RowSource = 'all' | 'custom' | 'filtered' | 'page' | 'selected'

type AggregationTableMeta = {
  rowSource: RowSource
}

const features = {
  rowAggregationFeature,
  columnFilteringFeature,
  rowPaginationFeature,
  rowSelectionFeature,
  filteredRowModel: createFilteredRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  filterFns: { includesString: filterFn_includesString },
  aggregationFns: {
    count: aggregationFn_count,
    extent: aggregationFn_extent,
    mean: aggregationFn_mean,
    sum: aggregationFn_sum,
  },
  tableMeta: metaHelper<AggregationTableMeta>(),
}

const columnHelper = createColumnHelper<typeof features, Sale>()

// demo purposes - optionally pass in custom rows to aggregate
function getAggregationRows(table: Table<typeof features, Sale>) {
  const rowSource = table.options.meta?.rowSource
  if (rowSource === 'all') return table.getCoreRowModel().rows
  if (rowSource === 'page') return table.getRowModel().rows
  if (rowSource === 'selected') {
    return table.getFilteredSelectedRowModel().rows
  }
  if (rowSource === 'custom') {
    return table.getCoreRowModel().rows.slice(0, 3)
  }
  return undefined
}

function formatValue(value: unknown): string {
  if (Array.isArray(value)) return value.map(formatValue).join(' – ')
  if (value && typeof value === 'object') {
    return Object.entries(value)
      .map(([key, entry]) => `${key}: ${formatValue(entry)}`)
      .join(', ')
  }
  if (typeof value === 'number')
    return value.toLocaleString(undefined, { maximumFractionDigits: 2 })
  return String(value ?? '—')
}

function App() {
  const [data, setData] = React.useState(() => makeData(10_000))
  const [rowSource, setRowSource] = React.useState<RowSource>('filtered')
  const columns = React.useMemo(
    () =>
      columnHelper.columns([
        columnHelper.display({
          id: 'select',
          header: ({ table }) => (
            <input
              type="checkbox"
              checked={table.getIsAllPageRowsSelected()}
              onChange={table.getToggleAllPageRowsSelectedHandler()}
            />
          ),
          cell: ({ row }) => (
            <input
              type="checkbox"
              checked={row.getIsSelected()}
              onChange={row.getToggleSelectedHandler()}
            />
          ),
        }),
        columnHelper.accessor('category', {
          header: 'Category',
          filterFn: 'includesString',
        }),
        columnHelper.accessor('item', {
          header: 'Item',
          footer: ({ table }) => `${table.options.meta?.rowSource} total`,
        }),
        columnHelper.accessor('amount', {
          header: 'Amount',
          aggregationFn: 'sum',
          // maxAggregationDepth: 1, // include one level of descendants in this column's aggregate
          // getAggregationValue: () => ({ value: 0 }), // provide a precomputed value and skip local fallback
          cell: ({ getValue }) => getValue<number>().toLocaleString(),
          footer: ({ column, table }) =>
            formatValue(
              column.getAggregationValue({
                // Omit `rows` to use the filtered, pre-grouped rows by default.
                rows: getAggregationRows(table),
              }),
            ),
        }),
        columnHelper.accessor('score', {
          header: 'Score',
          aggregationFn: [
            'count',
            'mean',
            { id: 'range', aggregationFn: 'extent' },
          ],
          footer: ({ column, table }) =>
            formatValue(
              column.getAggregationValue({
                // Any row model or custom subset can define the total's roots.
                rows: getAggregationRows(table),
              }),
            ),
        }),
      ]),
    [],
  )

  const table = useTable(
    {
      features,
      columns,
      data,
      meta: { rowSource },
      initialState: { pagination: { pageIndex: 0, pageSize: 10 } },
      // manualAggregation: true, // supply aggregate values yourself instead of calculating them locally
      debugTable: true,
      debugColumns: true,
    },
    (state) => state, // default selector
  )

  return (
    <div className="demo-root">
      <h1>Aggregation without grouping</h1>
      <p>
        Amount uses a scalar <code>sum</code>. Score runs count, mean, and range
        together and returns a keyed object.
      </p>
      <div>
        <button onClick={() => setData(makeData(10_000))}>
          Regenerate Data
        </button>
        <button onClick={() => setData(makeData(1_000_000))}>
          Stress Test (1M rows)
        </button>
      </div>
      <div className="spacer-sm" />
      <div className="controls">
        <label>
          Category filter:{' '}
          <input
            value={
              (table.getColumn('category')?.getFilterValue() ?? '') as string
            }
            onChange={(event) =>
              table.getColumn('category')?.setFilterValue(event.target.value)
            }
          />
        </label>
        <label>
          Total rows:{' '}
          <select
            value={rowSource}
            onChange={(event) => setRowSource(event.target.value as RowSource)}
          >
            <option value="filtered">Filtered rows</option>
            <option value="all">All rows</option>
            <option value="page">Visible page</option>
            <option value="selected">Filtered selected rows</option>
            <option value="custom">First three core rows</option>
          </select>
        </label>
      </div>
      <div className="spacer-sm" />
      <table>
        <thead>
          {table.getHeaderGroups().map((headerGroup) => (
            <tr key={headerGroup.id}>
              {headerGroup.headers.map((header) => (
                <th key={header.id}>
                  {header.isPlaceholder ? null : (
                    <table.FlexRender header={header} />
                  )}
                </th>
              ))}
            </tr>
          ))}
        </thead>
        <tbody>
          {table.getRowModel().rows.map((row) => (
            <tr key={row.id}>
              {row.getAllCells().map((cell) => (
                <td
                  key={cell.id}
                  className={
                    cell.column.id === 'amount' ? 'numeric' : undefined
                  }
                >
                  <table.FlexRender cell={cell} />
                </td>
              ))}
            </tr>
          ))}
        </tbody>
        <tfoot>
          {table.getFooterGroups().map((footerGroup) => (
            <tr key={footerGroup.id}>
              {footerGroup.headers.map((header) => (
                <th key={header.id} colSpan={header.colSpan}>
                  {header.isPlaceholder ? null : (
                    <table.FlexRender footer={header} />
                  )}
                </th>
              ))}
            </tr>
          ))}
        </tfoot>
      </table>
      <div className="spacer-sm" />
      <div className="controls">
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.firstPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.lastPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span className="inline-controls">
          <div>Page</div>
          <strong>
            {(table.state.pagination.pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span className="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.state.pagination.pageIndex + 1}
            onChange={(event) => {
              const page = event.target.value
                ? Number(event.target.value) - 1
                : 0
              table.setPageIndex(page)
            }}
            className="page-size-input"
          />
        </span>
        <select
          value={table.state.pagination.pageSize}
          onChange={(event) => table.setPageSize(Number(event.target.value))}
        >
          {[10, 20, 30, 40, 50].map((pageSize) => (
            <option key={pageSize} value={pageSize}>
              Show {pageSize}
            </option>
          ))}
        </select>
      </div>
      <div>
        Showing {table.getRowModel().rows.length.toLocaleString()} of{' '}
        {table.getRowCount().toLocaleString()} Rows
      </div>
      <pre data-testid="table-state">
        {JSON.stringify(table.state, null, 2)}
      </pre>
    </div>
  )
}

const rootElement = document.getElementById('root')
if (!rootElement) throw new Error('Failed to find the root element')
ReactDOM.createRoot(rootElement).render(
  <React.StrictMode>
    <App />
  </React.StrictMode>,
)

Vue Example: Aggregation

<script setup lang="ts">
import {
  FlexRender,
  rowAggregationFeature,
  aggregationFn_count,
  aggregationFn_extent,
  aggregationFn_mean,
  aggregationFn_sum,
  columnFilteringFeature,
  createColumnHelper,
  createFilteredRowModel,
  createPaginatedRowModel,
  filterFn_includesString,
  metaHelper,
  rowPaginationFeature,
  rowSelectionFeature,
  tableFeatures,
  useTable,
} from '@tanstack/vue-table'
import { ref } from 'vue'
import { makeData } from './makeData'
import type { Sale } from './makeData'
import type { Table } from '@tanstack/vue-table'

type RowSource = 'all' | 'custom' | 'filtered' | 'page' | 'selected'
type AggregationTableMeta = { rowSource: RowSource }
const features = tableFeatures({
  rowAggregationFeature,
  columnFilteringFeature,
  rowPaginationFeature,
  rowSelectionFeature,
  filteredRowModel: createFilteredRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  filterFns: { includesString: filterFn_includesString },
  aggregationFns: {
    count: aggregationFn_count,
    extent: aggregationFn_extent,
    mean: aggregationFn_mean,
    sum: aggregationFn_sum,
  },
  tableMeta: metaHelper<AggregationTableMeta>(),
})
const columnHelper = createColumnHelper<typeof features, Sale>()
function getAggregationRows(table: Table<typeof features, Sale>) {
  const source = table.options.meta?.rowSource
  if (source === 'all') return table.getCoreRowModel().rows
  if (source === 'page') return table.getRowModel().rows
  if (source === 'selected') return table.getFilteredSelectedRowModel().rows
  if (source === 'custom') return table.getCoreRowModel().rows.slice(0, 3)
  return undefined
}
function formatValue(value: unknown): string {
  if (Array.isArray(value)) return value.map(formatValue).join(' – ')
  if (value && typeof value === 'object')
    return Object.entries(value)
      .map(([key, entry]) => `${key}: ${formatValue(entry)}`)
      .join(', ')
  if (typeof value === 'number')
    return value.toLocaleString(undefined, { maximumFractionDigits: 2 })
  return String(value ?? '—')
}
const data = ref(makeData(10_000))
const rowSource = ref<RowSource>('filtered')
const columns = columnHelper.columns([
  columnHelper.display({ id: 'select' }),
  columnHelper.accessor('category', {
    header: 'Category',
    filterFn: 'includesString',
  }),
  columnHelper.accessor('item', {
    header: 'Item',
    footer: ({ table }) => `${table.options.meta?.rowSource} total`,
  }),
  columnHelper.accessor('amount', {
    header: 'Amount',
    aggregationFn: 'sum',
    cell: ({ getValue }) => getValue<number>().toLocaleString(),
    footer: ({ column, table }) =>
      formatValue(
        column.getAggregationValue({ rows: getAggregationRows(table) }),
      ),
  }),
  columnHelper.accessor('score', {
    header: 'Score',
    aggregationFn: ['count', 'mean', { id: 'range', aggregationFn: 'extent' }],
    footer: ({ column, table }) =>
      formatValue(
        column.getAggregationValue({ rows: getAggregationRows(table) }),
      ),
  }),
])
const table = useTable({
  features,
  data,
  columns,
  get meta() {
    return { rowSource: rowSource.value }
  },
  initialState: { pagination: { pageIndex: 0, pageSize: 10 } },
  // manualAggregation: true, // supply aggregate values yourself instead of calculating them locally
  debugTable: true,
  debugColumns: true,
})
function setCategoryFilter(event: Event) {
  table
    .getColumn('category')
    ?.setFilterValue((event.target as HTMLInputElement).value)
}
function setRowSource(event: Event) {
  rowSource.value = (event.target as HTMLSelectElement).value as RowSource
}
function setPage(event: Event) {
  const value = (event.target as HTMLInputElement).value
  table.setPageIndex(value ? Number(value) - 1 : 0)
}
</script>

<template>
  <div class="demo-root">
    <h1>Aggregation without grouping</h1>
    <p>
      Amount uses a scalar <code>sum</code>. Score runs count, mean, and range
      together and returns a keyed object.
    </p>
    <div>
      <button @click="data = makeData(10_000)">Regenerate Data</button
      ><button @click="data = makeData(1_000_000)">
        Stress Test (1M rows)
      </button>
    </div>
    <div class="spacer-sm" />
    <div class="controls">
      <label
        >Category filter:
        <input
          :value="table.getColumn('category')?.getFilterValue() ?? ''"
          @input="setCategoryFilter"
      /></label>
      <label
        >Total rows:
        <select :value="rowSource" @change="setRowSource">
          <option value="filtered">Filtered rows</option>
          <option value="all">All rows</option>
          <option value="page">Visible page</option>
          <option value="selected">Filtered selected rows</option>
          <option value="custom">First three core rows</option>
        </select></label
      >
    </div>
    <div class="spacer-sm" />
    <table>
      <thead>
        <tr v-for="group in table.getHeaderGroups()" :key="group.id">
          <th v-for="header in group.headers" :key="header.id">
            <input
              v-if="header.column.id === 'select'"
              type="checkbox"
              :checked="table.getIsAllPageRowsSelected()"
              @change="table.toggleAllPageRowsSelected()"
            /><FlexRender v-else-if="!header.isPlaceholder" :header="header" />
          </th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="row in table.getRowModel().rows" :key="row.id">
          <td
            v-for="cell in row.getAllCells()"
            :key="cell.id"
            :class="{ numeric: cell.column.id === 'amount' }"
          >
            <input
              v-if="cell.column.id === 'select'"
              type="checkbox"
              :checked="row.getIsSelected()"
              @change="row.toggleSelected()"
            /><FlexRender v-else :cell="cell" />
          </td>
        </tr>
      </tbody>
      <tfoot>
        <tr v-for="group in table.getFooterGroups()" :key="group.id">
          <th
            v-for="header in group.headers"
            :key="header.id"
            :colspan="header.colSpan"
          >
            <FlexRender v-if="!header.isPlaceholder" :footer="header" />
          </th>
        </tr>
      </tfoot>
    </table>
    <div class="spacer-sm" />
    <div class="controls">
      <button
        class="demo-button demo-button-sm"
        @click="table.firstPage()"
        :disabled="!table.getCanPreviousPage()"
      >
        &lt;&lt;</button
      ><button
        class="demo-button demo-button-sm"
        @click="table.previousPage()"
        :disabled="!table.getCanPreviousPage()"
      >
        &lt;</button
      ><button
        class="demo-button demo-button-sm"
        @click="table.nextPage()"
        :disabled="!table.getCanNextPage()"
      >
        &gt;</button
      ><button
        class="demo-button demo-button-sm"
        @click="table.lastPage()"
        :disabled="!table.getCanNextPage()"
      >
        &gt;&gt;
      </button>
      <span class="inline-controls"
        ><div>Page</div>
        <strong
          >{{
            (table.atoms.pagination.get().pageIndex + 1).toLocaleString()
          }}
          of {{ table.getPageCount().toLocaleString() }}</strong
        ></span
      >
      <span class="inline-controls"
        >| Go to page:<input
          type="number"
          min="1"
          :max="table.getPageCount()"
          :value="table.atoms.pagination.get().pageIndex + 1"
          @input="setPage"
          class="page-size-input"
      /></span>
      <select
        :value="table.atoms.pagination.get().pageSize"
        @change="
          table.setPageSize(Number(($event.target as HTMLSelectElement).value))
        "
      >
        <option v-for="size in [10, 20, 30, 40, 50]" :key="size" :value="size">
          Show {{ size }}
        </option>
      </select>
    </div>
    <div>
      Showing {{ table.getRowModel().rows.length.toLocaleString() }} of
      {{ table.getRowCount().toLocaleString() }} Rows
    </div>
    <pre data-testid="table-state">{{
      JSON.stringify(table.store.get(), null, 2)
    }}</pre>
  </div>
</template>
<script setup lang="ts">
import {
  FlexRender,
  rowAggregationFeature,
  aggregationFn_count,
  aggregationFn_extent,
  aggregationFn_mean,
  aggregationFn_sum,
  columnFilteringFeature,
  createColumnHelper,
  createFilteredRowModel,
  createPaginatedRowModel,
  filterFn_includesString,
  metaHelper,
  rowPaginationFeature,
  rowSelectionFeature,
  tableFeatures,
  useTable,
} from '@tanstack/vue-table'
import { ref } from 'vue'
import { makeData } from './makeData'
import type { Sale } from './makeData'
import type { Table } from '@tanstack/vue-table'

type RowSource = 'all' | 'custom' | 'filtered' | 'page' | 'selected'
type AggregationTableMeta = { rowSource: RowSource }
const features = tableFeatures({
  rowAggregationFeature,
  columnFilteringFeature,
  rowPaginationFeature,
  rowSelectionFeature,
  filteredRowModel: createFilteredRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  filterFns: { includesString: filterFn_includesString },
  aggregationFns: {
    count: aggregationFn_count,
    extent: aggregationFn_extent,
    mean: aggregationFn_mean,
    sum: aggregationFn_sum,
  },
  tableMeta: metaHelper<AggregationTableMeta>(),
})
const columnHelper = createColumnHelper<typeof features, Sale>()
function getAggregationRows(table: Table<typeof features, Sale>) {
  const source = table.options.meta?.rowSource
  if (source === 'all') return table.getCoreRowModel().rows
  if (source === 'page') return table.getRowModel().rows
  if (source === 'selected') return table.getFilteredSelectedRowModel().rows
  if (source === 'custom') return table.getCoreRowModel().rows.slice(0, 3)
  return undefined
}
function formatValue(value: unknown): string {
  if (Array.isArray(value)) return value.map(formatValue).join(' – ')
  if (value && typeof value === 'object')
    return Object.entries(value)
      .map(([key, entry]) => `${key}: ${formatValue(entry)}`)
      .join(', ')
  if (typeof value === 'number')
    return value.toLocaleString(undefined, { maximumFractionDigits: 2 })
  return String(value ?? '—')
}
const data = ref(makeData(10_000))
const rowSource = ref<RowSource>('filtered')
const columns = columnHelper.columns([
  columnHelper.display({ id: 'select' }),
  columnHelper.accessor('category', {
    header: 'Category',
    filterFn: 'includesString',
  }),
  columnHelper.accessor('item', {
    header: 'Item',
    footer: ({ table }) => `${table.options.meta?.rowSource} total`,
  }),
  columnHelper.accessor('amount', {
    header: 'Amount',
    aggregationFn: 'sum',
    cell: ({ getValue }) => getValue<number>().toLocaleString(),
    footer: ({ column, table }) =>
      formatValue(
        column.getAggregationValue({ rows: getAggregationRows(table) }),
      ),
  }),
  columnHelper.accessor('score', {
    header: 'Score',
    aggregationFn: ['count', 'mean', { id: 'range', aggregationFn: 'extent' }],
    footer: ({ column, table }) =>
      formatValue(
        column.getAggregationValue({ rows: getAggregationRows(table) }),
      ),
  }),
])
const table = useTable({
  features,
  data,
  columns,
  get meta() {
    return { rowSource: rowSource.value }
  },
  initialState: { pagination: { pageIndex: 0, pageSize: 10 } },
  // manualAggregation: true, // supply aggregate values yourself instead of calculating them locally
  debugTable: true,
  debugColumns: true,
})
function setCategoryFilter(event: Event) {
  table
    .getColumn('category')
    ?.setFilterValue((event.target as HTMLInputElement).value)
}
function setRowSource(event: Event) {
  rowSource.value = (event.target as HTMLSelectElement).value as RowSource
}
function setPage(event: Event) {
  const value = (event.target as HTMLInputElement).value
  table.setPageIndex(value ? Number(value) - 1 : 0)
}
</script>

<template>
  <div class="demo-root">
    <h1>Aggregation without grouping</h1>
    <p>
      Amount uses a scalar <code>sum</code>. Score runs count, mean, and range
      together and returns a keyed object.
    </p>
    <div>
      <button @click="data = makeData(10_000)">Regenerate Data</button
      ><button @click="data = makeData(1_000_000)">
        Stress Test (1M rows)
      </button>
    </div>
    <div class="spacer-sm" />
    <div class="controls">
      <label
        >Category filter:
        <input
          :value="table.getColumn('category')?.getFilterValue() ?? ''"
          @input="setCategoryFilter"
      /></label>
      <label
        >Total rows:
        <select :value="rowSource" @change="setRowSource">
          <option value="filtered">Filtered rows</option>
          <option value="all">All rows</option>
          <option value="page">Visible page</option>
          <option value="selected">Filtered selected rows</option>
          <option value="custom">First three core rows</option>
        </select></label
      >
    </div>
    <div class="spacer-sm" />
    <table>
      <thead>
        <tr v-for="group in table.getHeaderGroups()" :key="group.id">
          <th v-for="header in group.headers" :key="header.id">
            <input
              v-if="header.column.id === 'select'"
              type="checkbox"
              :checked="table.getIsAllPageRowsSelected()"
              @change="table.toggleAllPageRowsSelected()"
            /><FlexRender v-else-if="!header.isPlaceholder" :header="header" />
          </th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="row in table.getRowModel().rows" :key="row.id">
          <td
            v-for="cell in row.getAllCells()"
            :key="cell.id"
            :class="{ numeric: cell.column.id === 'amount' }"
          >
            <input
              v-if="cell.column.id === 'select'"
              type="checkbox"
              :checked="row.getIsSelected()"
              @change="row.toggleSelected()"
            /><FlexRender v-else :cell="cell" />
          </td>
        </tr>
      </tbody>
      <tfoot>
        <tr v-for="group in table.getFooterGroups()" :key="group.id">
          <th
            v-for="header in group.headers"
            :key="header.id"
            :colspan="header.colSpan"
          >
            <FlexRender v-if="!header.isPlaceholder" :footer="header" />
          </th>
        </tr>
      </tfoot>
    </table>
    <div class="spacer-sm" />
    <div class="controls">
      <button
        class="demo-button demo-button-sm"
        @click="table.firstPage()"
        :disabled="!table.getCanPreviousPage()"
      >
        &lt;&lt;</button
      ><button
        class="demo-button demo-button-sm"
        @click="table.previousPage()"
        :disabled="!table.getCanPreviousPage()"
      >
        &lt;</button
      ><button
        class="demo-button demo-button-sm"
        @click="table.nextPage()"
        :disabled="!table.getCanNextPage()"
      >
        &gt;</button
      ><button
        class="demo-button demo-button-sm"
        @click="table.lastPage()"
        :disabled="!table.getCanNextPage()"
      >
        &gt;&gt;
      </button>
      <span class="inline-controls"
        ><div>Page</div>
        <strong
          >{{
            (table.atoms.pagination.get().pageIndex + 1).toLocaleString()
          }}
          of {{ table.getPageCount().toLocaleString() }}</strong
        ></span
      >
      <span class="inline-controls"
        >| Go to page:<input
          type="number"
          min="1"
          :max="table.getPageCount()"
          :value="table.atoms.pagination.get().pageIndex + 1"
          @input="setPage"
          class="page-size-input"
      /></span>
      <select
        :value="table.atoms.pagination.get().pageSize"
        @change="
          table.setPageSize(Number(($event.target as HTMLSelectElement).value))
        "
      >
        <option v-for="size in [10, 20, 30, 40, 50]" :key="size" :value="size">
          Show {{ size }}
        </option>
      </select>
    </div>
    <div>
      Showing {{ table.getRowModel().rows.length.toLocaleString() }} of
      {{ table.getRowCount().toLocaleString() }} Rows
    </div>
    <pre data-testid="table-state">{{
      JSON.stringify(table.store.get(), null, 2)
    }}</pre>
  </div>
</template>